/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.GameCanvas;

/**
 * @author DDDEN!SSS
 */
public class MIDPCanvas extends GameCanvas implements Runnable {
    private final Graphics g = getGraphics();
    private Thread thread;
    private boolean running;
    private int key = 0;
    
    private final Texture texture = new Texture("/texture.jpg");
    private final Vertex[] vertexs = new Vertex[3];
    private RGB rgb;
    private Polygon polygon;
    private int editVertex = 2;
    
    public MIDPCanvas() {
        super(false);
        setFullScreenMode(true);
        
        rgb = new RGB(getWidth(), getHeight());
        
        vertexs[0] = new Vertex(0,0,  0, 0);
        vertexs[1] = new Vertex(0, getHeight(),  0, 112);
        vertexs[2] = new Vertex(getWidth(), getHeight(),  149, 112);
        
        polygon = new Polygon(vertexs[0], vertexs[1], vertexs[2], texture);
    } 
    
    public void threadStart() {
        running = true;
        thread = new Thread(this);
        thread.start();
    }
    
    public void paint() {
        //g.setColor(0);
        //g.fillRect(0, 0, getWidth(), getHeight());
        
        rgb.setFon(0);
        try {
            polygon.paintTexture(rgb);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        
        rgb.paint(g);
        
        g.setColor(0xffffff);
        g.drawString(""+Fps.fps(), 0, 0, 0);
        flushGraphics();
    }
    
    
    protected  void keyPressed(int k) {
        key = k;
        if(k == Canvas.KEY_NUM5) {
            editVertex++;
            if(editVertex > vertexs.length-1) {
                editVertex = 0;
            }
        }
        
        int s = 1;
        
        if(key==-1) { //up
            vertexs[editVertex].sy-=s;
        }
        if(key==-2) { //down
            vertexs[editVertex].sy+=s;
        }
        if(key==-3) { //left
            vertexs[editVertex].sx-=s;
        }
        if(key==-4) { //right
            vertexs[editVertex].sx+=s;
        }
    }
    protected  void keyRepeated(int k) {
        keyPressed(k);
    }
    
    protected  void keyReleased(int k) {
        key = 0;
    }
    
    private void key() {
        int s = 6;
        if(key==50) { //up
            vertexs[editVertex].sy-=s;
        }
        if(key==56) { //down
            vertexs[editVertex].sy+=s;
        }
        if(key==52) { //left
            vertexs[editVertex].sx-=s;
        }
        if(key==54) { //right
            vertexs[editVertex].sx+=s;
        }
    }
    
    
    
    public void run() {
        while(running) {
            
            
            key();
            paint();
            try {
                Thread.sleep(1L);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
        }
    }
    
    
}